package org.dromara.elevator.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.SpringUtils;
import org.dromara.common.core.utils.ValidatorUtils;
import org.dromara.common.excel.core.ExcelListener;
import org.dromara.common.excel.core.ExcelResult;
import org.dromara.elevator.domain.bo.EFactoryInfoBo;
import org.dromara.elevator.domain.vo.EFactoryInfoIpmortVo;
import org.dromara.elevator.domain.vo.EFactoryInfoVo;
import org.dromara.elevator.service.IEFactoryInfoService;

import java.util.List;

/**
 * 导入生产厂家基础信息
 *
 * @author zy
 */
@Slf4j
public class EFactoryInfoImportListener extends AnalysisEventListener<EFactoryInfoIpmortVo> implements ExcelListener<EFactoryInfoIpmortVo> {

    private final IEFactoryInfoService factoryInfoService;

    private final Boolean isUpdateSupport;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public EFactoryInfoImportListener(Boolean isUpdateSupport) {
        this.factoryInfoService = SpringUtils.getBean(IEFactoryInfoService.class);
        this.isUpdateSupport = isUpdateSupport;
    }

    @Override
    public void invoke(EFactoryInfoIpmortVo factoryVo, AnalysisContext context) {

        EFactoryInfoVo factoryInfo = this.factoryInfoService.selectByCode(factoryVo.getCode());
        try {
            // 验证是否存在这个用户
            if (ObjectUtil.isNull(factoryInfo)) {
                EFactoryInfoBo factory = BeanUtil.toBean(factoryVo, EFactoryInfoBo.class);
                ValidatorUtils.validate(factory);
                factoryInfoService.insertByBo(factory);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、生产厂家 ").append(factory.getName()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long factoryId = factoryInfo.getId();
                EFactoryInfoBo factoryInfoBo = BeanUtil.toBean(factoryVo, EFactoryInfoBo.class);
                factoryInfoBo.setId(factoryId);
                ValidatorUtils.validate(factoryInfoBo);
                factoryInfoService.updateByBo(factoryInfoBo);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、生产厂家 ").append(factoryVo.getName()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、生产厂家 ").append(factoryVo.getName()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、生产厂家 " + factoryVo.getName() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<EFactoryInfoIpmortVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<EFactoryInfoIpmortVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
